<?php

class ET_Builder_Module_Fullwidth_Header_slide extends ET_Builder_Module {

	function init() {

		$this->name             = esc_html__( 'Lama - Fullwidth Header with slider', 'et_builder' );

		$this->slug             = 'et_pb_fullwidth_header_slider';

		$this->fb_support       = true;

		$this->fullwidth        = true; 

		$this->main_css_element = '%%order_class%%';



		$this->whitelisted_fields = array(

			'title',

			'subhead',

			'background_layout', 

			'text_orientation',

			'header_fullscreen',

			'header_scroll_down',

			'scroll_down_icon',

			'scroll_down_icon_color',

			'scroll_down_icon_size',

			'scroll_down_icon_size_tablet',

			'scroll_down_icon_size_phone',

			'scroll_down_icon_size_last_edited',

			'title_font_color',

			'subhead_font_color',

			'content_font_color',

			'max_width',

			'max_width_tablet',

			'max_width_phone',

			'max_width_last_edited',

			'button_one_text',

			'button_one_url',

			'button_two_text',

			'button_two_url',

			'background_url',

			'background_slider_on',

			'background_url2',

			'background_url3',

			'background_url4',

			'background_url5',

			'background_url6',

			'background_url7',

			'background_url8',

			'background_url9',

			'background_url10',

			'background_animation_speed',

			'background_color',

			'background_overlay_color',

			'parallax',

			'parallax_method',

			'logo_image_url',

			'logo_title',

			'logo_alt_text',

			'content_orientation',

			'header_image_url',

			'image_orientation',

			'content_new',

			'admin_label',

			'module_id',

			'module_class',

		);



		$this->fields_defaults = array(

			'background_layout'   => array( 'light' ),

			'text_orientation'    => array( 'left' ),

			'header_fullscreen'   => array( 'off' ),

			'background_slider_on'   => array( 'off' ),

			'header_scroll_down'  => array( 'off' ),

			'scroll_down_icon'    => array( ';', 'add_default_setting' ),

			'parallax'            => array( 'off' ),

			'parallax_method'     => array( 'off' ),

			'content_orientation' => array( 'center' ),

			'image_orientation'   => array( 'center' ),

		);



		$this->options_toggles = array(

			'advanced' => array(

				'settings' => array(

					'toggles_disabled' => true,

				),

				'toggles' => array(

					'title_styles'   => esc_html__( 'Title Styling', 'et_builder' ),

					'subhead_styles' => esc_html__( 'Subhead Styling', 'et_builder' ),

					'content_styles' => esc_html__( 'Content Styling', 'et_builder' ),

				),

			),

		);

		$this->advanced_options = array(

			'fonts' => array(

				'title' => array(

					'label'    => esc_html__( 'Title', 'et_builder' ),

					'css'      => array(

						'main' => "%%order_class%%.et_pb_fullwidth_header .header-content h1",

					),

					'font_size' => array(

						'toggle_slug'  => 'title_styles',

						'default'      => '30px',

					),

					'font' => array(

						'toggle_slug'  => 'title_styles',

					),

					'hide_line_height'    => true,

					'hide_text_color'     => true,

					'hide_letter_spacing' => true,

				),

				'subhead' => array(

					'label'    => esc_html__( 'Subhead', 'et_builder' ),

					'css'      => array(

						'main' => "%%order_class%%.et_pb_fullwidth_header .et_pb_fullwidth_header_subhead",

					),

					'font_size' => array(

						'toggle_slug'  => 'subhead_styles',

					),

					'font' => array(

						'toggle_slug'  => 'subhead_styles',

					),

					'hide_line_height'    => true,

					'hide_text_color'     => true,

					'hide_letter_spacing' => true,

				),

				'content' => array(

					'label'    => esc_html__( 'Content', 'et_builder' ),

					'css'      => array(

						'main' => "%%order_class%%.et_pb_fullwidth_header p",

					),

					'font_size' => array(

						'toggle_slug'  => 'content_styles',

						'default'      => '14px',

					),

					'font' => array(

						'toggle_slug'  => 'content_styles',

					),

					'hide_line_height'    => true,

					'hide_text_color'     => true,

					'hide_letter_spacing' => true,

				),

			),

			'button' => array(

				'button_one' => array(

					'label' => esc_html__( 'Button One', 'et_builder' ),

					'css'      => array(

						'main' => "{$this->main_css_element} .et_pb_button_one.et_pb_button",

					),

				),

				'button_two' => array(

					'label' => esc_html__( 'Button Two', 'et_builder' ),

					'css'      => array(

						'main' => "{$this->main_css_element} .et_pb_button_two.et_pb_button",

					),

				),

			),

		);



		$this->custom_css_options = array(

			'header_container' => array(

				'label'    => esc_html__( 'Header Container', 'et_builder' ),

				'selector' => '.et_pb_fullwidth_header_container',

			),

			'header_image' => array(

				'label'    => esc_html__( 'Header Image', 'et_builder' ),

				'selector' => '.et_pb_fullwidth_header_container .header-image img',

			),

			'logo' => array(

				'label'    => esc_html__( 'Logo', 'et_builder' ),

				'selector' => '.header-content img',

			),

			'title' => array(

				'label'    => esc_html__( 'Title', 'et_builder' ),

				'selector' => '.header-content h1',

			),

			'subtitle' => array(

				'label'    => esc_html__( 'Subtitle', 'et_builder' ),

				'selector' => '.header-content .et_pb_fullwidth_header_subhead',

			),

			'button_1' => array(

				'label'    => esc_html__( 'Button One', 'et_builder' ),

				'selector' => '.header-content-container .header-content .et_pb_button_one.et_pb_button',

			),

			'button_2' => array(

				'label'    => esc_html__( 'Button Two', 'et_builder' ),

				'selector' => '.header-content-container .header-content .et_pb_button_two.et_pb_button',

			),

			'scroll_button' => array(

				'label'    => esc_html__( 'Scroll Down Button', 'et_builder' ),

				'selector' => '.et_pb_fullwidth_header_scroll a .et-pb-icon',

			),

		);

	}



	function get_fields() {

		$fields = array(

			'title' => array(

				'label'           => esc_html__( 'Title', 'et_builder' ),

				'type'            => 'text',

				'option_category' => 'basic_option',

				'description'     => esc_html__( 'Enter your page title here.', 'et_builder' ),

			),

			'subhead' => array(

				'label'           => esc_html__( 'Subheading Text', 'et_builder' ),

				'type'            => 'text',

				'option_category' => 'basic_option',

				'description'     => esc_html__( 'If you would like to use a subhead, add it here. Your subhead will appear below your title in a small font.', 'et_builder' ),

			),

			'background_layout' => array(

				'label'           => esc_html__( 'Text Color', 'et_builder' ),

				'type'            => 'select',

				'option_category' => 'color_option',

				'options'         => array(

					'light' => esc_html__( 'Dark', 'et_builder' ),

					'dark'  => esc_html__( 'Light', 'et_builder' ),

				),

				'description'       => esc_html__( 'Here you can choose the value of your text. If you are working with a dark background, then your text should be set to light. If you are working with a light background, then your text should be dark.', 'et_builder' ),

			),

			'text_orientation' => array(

				'label'             => esc_html__( 'Text & Logo Orientation', 'et_builder' ),

				'type'              => 'select',

				'option_category'   => 'layout',

				'options'           => et_builder_get_text_orientation_options(),

				'description'       => esc_html__( 'This controls the how your text is aligned within the module.', 'et_builder' ),

			),



			'header_fullscreen' => array(

				'label'           => esc_html__( 'Make Fullscreen', 'et_builder' ),

				'type'            => 'yes_no_button',

				'option_category' => 'configuration',

				'options'         => array(

					'off' => esc_html__( 'No', 'et_builder' ),

					'on'  => esc_html__( 'Yes', 'et_builder' ),

				),

				'affects'           => array(

					'content_orientation',

				),

				'description'       => esc_html__( 'Here you can choose whether the header is expanded to fullscreen size.', 'et_builder' ),

			),

			'header_scroll_down' => array(

				'label'           => esc_html__( 'Show Scroll Down Button', 'et_builder' ),

				'type'            => 'yes_no_button',

				'option_category' => 'configuration',

				'options'         => array(

					'off' => esc_html__( 'No', 'et_builder' ),

					'on'  => esc_html__( 'Yes', 'et_builder' ),

				),

				'affects'           => array(

					'scroll_down_icon',

				),

				'description'       => esc_html__( 'Here you can choose whether the scroll down button is shown.', 'et_builder' ),

			),

			'scroll_down_icon' => array(

				'label'               => esc_html__( 'Icon', 'et_builder' ),

				'type'                => 'text',

				'option_category'     => 'configuration',

				'class'               => array( 'et-pb-font-icon' ),

				'renderer'            => 'et_pb_get_font_down_icon_list',

				'renderer_with_field' => true,

				'description'         => esc_html__( 'Choose an icon to display for the scroll down button.', 'et_builder' ),

				'depends_show_if'     => 'on',

			),

			'scroll_down_icon_color' => array(

				'label'             => esc_html__( 'Scroll Down Icon Color', 'et_builder' ),

				'type'              => 'color-alpha',

				'custom_color'      => true,

				'tab_slug'          => 'advanced',

			),

			'scroll_down_icon_size' => array(

				'label'           => esc_html__( 'Scroll Down Icon Size', 'et_builder' ),

				'type'            => 'range',

				'option_category' => 'layout',

				'mobile_options'  => true,

				'tab_slug'        => 'advanced',

			),

			'scroll_down_icon_size_tablet' => array(

				'type'     => 'skip',

				'tab_slug' => 'advanced',

			),

			'scroll_down_icon_size_phone' => array(

				'type'     => 'skip',

				'tab_slug' => 'advanced',

			),

			'scroll_down_icon_size_last_edited' => array(

				'type'     => 'skip',

				'tab_slug' => 'advanced',

			),

			'title_font_color' => array(

				'label'             => esc_html__( 'Title Font Color', 'et_builder' ),

				'type'              => 'color',

				'custom_color'      => true,

				'tab_slug'          => 'advanced',

				'toggle_slug'       => 'title_styles',

			),

			'subhead_font_color' => array(

				'label'             => esc_html__( 'Subhead Font Color', 'et_builder' ),

				'type'              => 'color',

				'custom_color'      => true,

				'tab_slug'          => 'advanced',

				'toggle_slug'       => 'subhead_styles',

			),

			'content_font_color' => array(

				'label'             => esc_html__( 'Content Font Color', 'et_builder' ),

				'type'              => 'color',

				'custom_color'      => true,

				'tab_slug'          => 'advanced',

				'toggle_slug'       => 'content_styles',

			),

			'max_width' => array(

				'label'           => esc_html__( 'Text Max Width', 'et_builder' ),

				'type'            => 'text',

				'option_category' => 'layout',

				'tab_slug'        => 'advanced',

				'mobile_options'  => true,

				'validate_unit'   => true,

			),

			'max_width_tablet' => array(

				'type'     => 'skip',

				'tab_slug' => 'advanced',

			),

			'max_width_phone' => array(

				'type'     => 'skip',

				'tab_slug' => 'advanced',

			),

			'max_width_last_edited' => array(

				'type'     => 'skip',

				'tab_slug' => 'advanced',

			),

			'button_one_text' => array(

				'label'           => sprintf( esc_html__( 'Button %1$s Text', 'et_builder' ), '#1' ),

				'type'            => 'text',

				'option_category' => 'basic_option',

				'description'     => esc_html__( 'Enter the text for the Button.', 'et_builder' ),

			),

			'button_one_url' => array(

				'label'           => sprintf( esc_html__( 'Button %1$s URL', 'et_builder' ), '#1' ),

				'type'            => 'text',

				'option_category' => 'basic_option',

				'description'     => esc_html__( 'Enter the URL for the Button.', 'et_builder' ),

			),

			'button_two_text' => array(

				'label'           => sprintf( esc_html__( 'Button %1$s Text', 'et_builder' ), '#2' ),

				'type'            => 'text',

				'option_category' => 'basic_option',

				'description'     => esc_html__( 'Enter the text for the Button.', 'et_builder' ),

			),

			'button_two_url' => array(

				'label'           => sprintf( esc_html__( 'Button %1$s URL', 'et_builder' ), '#2' ),

				'type'            => 'text',

				'option_category' => 'basic_option',

				'description'     => esc_html__( 'Enter the URL for the Button.', 'et_builder' ),

			),

			'background_url' => array(

				'label'              => esc_html__( 'Background Image URL', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

				'affects'           => array(

					'background_url2',

				),

			),

			'background_slider_on' => array(

				'label'           => esc_html__( 'Enable background slider', 'et_builder' ),

				'type'            => 'yes_no_button',

				'option_category' => 'configuration',

				'options'         => array(

					'off' => esc_html__( 'No', 'et_builder' ),

					'on'  => esc_html__( 'Yes', 'et_builder' ),

				),

				'affects'           => array(

					'background_url2',

					'background_url3',

					'background_url4',

					'background_url5',

					'background_url6',

					'background_url7',

					'background_url8',

					'background_url9',

					'background_url10',

					'background_animation_speed',

				),

				'description'       => esc_html__( 'Here you can choose whether the background slider is running.', 'et_builder' ),

			),

			'background_url2' => array(

				'label'              => esc_html__( 'Background Image URL 2', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

				'depends_show_if'     => 'on',

			),

			'background_url3' => array(

				'label'              => esc_html__( 'Background Image URL 3', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

				'depends_show_if'     => 'on',

			),

			'background_url4' => array(

				'label'              => esc_html__( 'Background Image URL 4', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

				'depends_show_if'     => 'on',

			),

			'background_url5' => array(

				'label'              => esc_html__( 'Background Image URL 5', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

				'depends_show_if'     => 'on',

			),

			'background_url6' => array(

				'label'              => esc_html__( 'Background Image URL 6', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

				'depends_show_if'     => 'on',

			),

			'background_url7' => array(

				'label'              => esc_html__( 'Background Image URL 7', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

				'depends_show_if'     => 'on',

			),

			'background_url8' => array(

				'label'              => esc_html__( 'Background Image URL 8', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

				'depends_show_if'     => 'on',

			),

			'background_url9' => array(

				'label'              => esc_html__( 'Background Image URL 9', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

				'depends_show_if'     => 'on',

			),

			'background_url10' => array(

				'label'              => esc_html__( 'Background Image URL 10', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

				'depends_show_if'     => 'on',

			),

			'background_animation_speed' => array(

				'label'           => esc_html__( 'Animation speed', 'et_builder' ),

				'type'            => 'text',

				'option_category' => 'basic_option',

				'description'     => esc_html__( 'Animation speed in seconds. Default: 10s', 'et_builder' ),

				'depends_show_if'     => 'on',

			),

			'background_color' => array(

				'label'             => esc_html__( 'Background Color', 'et_builder' ),

				'type'              => 'color-alpha',

			),

			'background_overlay_color' => array(

				'label'             => esc_html__( 'Background Overlay Color', 'et_builder' ),

				'type'              => 'color-alpha',

			),

			'parallax' => array(

				'label'           => esc_html__( 'Use Parallax effect', 'et_builder' ),

				'type'            => 'yes_no_button',

				'option_category' => 'configuration',

				'options'         => array(

					'off'  => esc_html__( 'No', 'et_builder' ),

					'on' => esc_html__( 'Yes', 'et_builder' ),

				),

				'affects'           => array(

					'parallax_method',

				),

				'description'        => esc_html__( 'If enabled, your background images will have a fixed position as your scroll, creating a fun parallax-like effect.', 'et_builder' ),

			),

			'parallax_method' => array(

				'label'           => esc_html__( 'Parallax method', 'et_builder' ),

				'type'            => 'select',

				'option_category' => 'configuration',

				'options'         => array(

					'off' => esc_html__( 'CSS', 'et_builder' ),

					'on'  => esc_html__( 'True Parallax', 'et_builder' ),

				),

				'depends_show_if'   => 'on',

				'description'       => esc_html__( 'Define the method, used for the parallax effect.', 'et_builder' ),

			),



			'logo_image_url' => array(

				'label'              => esc_html__( 'Logo Image URL', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

			),

			'logo_alt_text' => array(

				'label'           => esc_html__( 'Logo Image Alternative Text', 'et_builder' ),

				'type'            => 'text',

				'option_category' => 'basic_option',

				'description'     => esc_html__( 'This defines the HTML ALT text. A short description of your image can be placed here.', 'et_builder' ),

			),

			'logo_title' => array(

				'label'           => esc_html__( 'Logo Title', 'et_builder' ),

				'type'            => 'text',

				'option_category' => 'basic_option',

				'description'     => esc_html__( 'This defines the HTML Title text.', 'et_builder' ),

			),

			'content_orientation' => array(

				'label'           => esc_html__( 'Text Vertical Alignment', 'et_builder' ),

				'type'            => 'select',

				'option_category' => 'layout',

				'options'         => array(

					'center'  => esc_html__( 'Center', 'et_builder' ),

					'bottom' => esc_html__( 'Bottom', 'et_builder' ),

				),

				'description'        => esc_html__( 'This setting determines the vertical alignment of your content. Your content can either be vertically centered, or aligned to the bottom.', 'et_builder' ),

				'depends_show_if'    => 'on',

			),



			'header_image_url' => array(

				'label'              => esc_html__( 'Header Image URL', 'et_builder' ),

				'type'               => 'upload',

				'option_category'    => 'basic_option',

				'upload_button_text' => esc_attr__( 'Upload an image', 'et_builder' ),

				'choose_text'        => esc_attr__( 'Choose an Image', 'et_builder' ),

				'update_text'        => esc_attr__( 'Set As Image', 'et_builder' ),

				'description'        => esc_html__( 'Upload your desired image, or type in the URL to the image you would like to display.', 'et_builder' ),

			),

			'image_orientation' => array(

				'label'           => esc_html__( 'Image Vertical Alignment', 'et_builder' ),

				'type'            => 'select',

				'option_category' => 'layout',

				'options'         => array(

					'center'  => esc_html__( 'Vertically Centered', 'et_builder' ),

					'bottom' => esc_html__( 'Bottom', 'et_builder' ),

				),

				'description'        => esc_html__( 'This controls the orientation of the image within the module.', 'et_builder' ),

			),

			'content_new' => array(

				'label'           => esc_html__( 'Content', 'et_builder' ),

				'type'            => 'tiny_mce',

				'option_category' => 'basic_option',

				'description'     => esc_html__( 'Here you can define the content that will be placed within the infobox for the pin.', 'et_builder' ),

			),

			'disabled_on' => array(

				'label'           => esc_html__( 'Disable on', 'et_builder' ),

				'type'            => 'multiple_checkboxes',

				'options'         => array(

					'phone'   => esc_html__( 'Phone', 'et_builder' ),

					'tablet'  => esc_html__( 'Tablet', 'et_builder' ),

					'desktop' => esc_html__( 'Desktop', 'et_builder' ),

				),

				'additional_att'  => 'disable_on',

				'option_category' => 'configuration',

				'description'     => esc_html__( 'This will disable the module on selected devices', 'et_builder' ),

			),

			'admin_label' => array(

				'label'       => esc_html__( 'Admin Label', 'et_builder' ),

				'type'        => 'text',

				'description' => esc_html__( 'This will change the label of the module in the builder for easy identification.', 'et_builder' ),

			),

			'module_id' => array(

				'label'           => esc_html__( 'CSS ID', 'et_builder' ),

				'type'            => 'text',

				'option_category' => 'configuration',

				'tab_slug'        => 'custom_css',

				'option_class'    => 'et_pb_custom_css_regular',

			),

			'module_class' => array(

				'label'           => esc_html__( 'CSS Class', 'et_builder' ),

				'type'            => 'text',

				'option_category' => 'configuration',

				'tab_slug'        => 'custom_css',

				'option_class'    => 'et_pb_custom_css_regular',

			),

		);



		return $fields;

	}



	function shortcode_callback( $atts, $content = null, $function_name ) {

		$module_id                    = $this->shortcode_atts['module_id'];

		$module_class                 = $this->shortcode_atts['module_class'];

		$title                        = $this->shortcode_atts['title'];

		$subhead                      = $this->shortcode_atts['subhead'];

		$background_layout            = $this->shortcode_atts['background_layout'];

		$text_orientation             = $this->shortcode_atts['text_orientation'];

		$title_font_color             = $this->shortcode_atts['title_font_color'];

		$subhead_font_color           = $this->shortcode_atts['subhead_font_color'];

		$content_font_color           = $this->shortcode_atts['content_font_color'];

		$button_one_text              = $this->shortcode_atts['button_one_text'];

		$button_one_url               = $this->shortcode_atts['button_one_url'];

		$button_two_text              = $this->shortcode_atts['button_two_text'];

		$button_two_url               = $this->shortcode_atts['button_two_url'];

		$header_fullscreen            = $this->shortcode_atts['header_fullscreen'];

		$header_scroll_down           = $this->shortcode_atts['header_scroll_down'];

		$scroll_down_icon             = $this->shortcode_atts['scroll_down_icon'];

		$scroll_down_icon_color       = $this->shortcode_atts['scroll_down_icon_color'];

		$scroll_down_icon_size        = $this->shortcode_atts['scroll_down_icon_size'];

		$scroll_down_icon_size_tablet = $this->shortcode_atts['scroll_down_icon_size_tablet'];

		$scroll_down_icon_size_phone  = $this->shortcode_atts['scroll_down_icon_size_phone'];

		$scroll_down_icon_size_last_edited = $this->shortcode_atts['scroll_down_icon_size_last_edited'];

		$background_url               = $this->shortcode_atts['background_url'];

		$background_slider_on          = $this->shortcode_atts['background_slider_on'];

		$background_url2               = $this->shortcode_atts['background_url2'];

		$background_url3               = $this->shortcode_atts['background_url3'];

		$background_url4               = $this->shortcode_atts['background_url4'];

		$background_url5               = $this->shortcode_atts['background_url5'];

		$background_url6               = $this->shortcode_atts['background_url6'];

		$background_url7               = $this->shortcode_atts['background_url7'];

		$background_url8               = $this->shortcode_atts['background_url8'];

		$background_url9               = $this->shortcode_atts['background_url9'];

		$background_url10               = $this->shortcode_atts['background_url10'];

		$background_animation_speed    = $this->shortcode_atts['background_animation_speed'];

		$background_color             = $this->shortcode_atts['background_color'];

		$background_overlay_color     = $this->shortcode_atts['background_overlay_color'];

		$parallax                     = $this->shortcode_atts['parallax'];

		$parallax_method              = $this->shortcode_atts['parallax_method'];

		$logo_image_url               = $this->shortcode_atts['logo_image_url'];

		$header_image_url             = $this->shortcode_atts['header_image_url'];

		$content_orientation          = $this->shortcode_atts['content_orientation'];

		$image_orientation            = $this->shortcode_atts['image_orientation'];

		$custom_icon_1                = $this->shortcode_atts['button_one_icon'];

		$button_custom_1              = $this->shortcode_atts['custom_button_one'];

		$custom_icon_2                = $this->shortcode_atts['button_two_icon'];

		$button_custom_2              = $this->shortcode_atts['custom_button_two'];

		$max_width                    = $this->shortcode_atts['max_width'];

		$max_width_tablet             = $this->shortcode_atts['max_width_tablet'];

		$max_width_phone              = $this->shortcode_atts['max_width_phone'];

		$max_width_last_edited        = $this->shortcode_atts['max_width_last_edited'];

		$logo_title                   = $this->shortcode_atts['logo_title'];

		$logo_alt_text                = $this->shortcode_atts['logo_alt_text'];



		if ( is_rtl() && 'left' === $text_orientation ) {

			$text_orientation = 'right';

		}



		$module_class = ET_Builder_Element::add_module_order_class( $module_class, $function_name );



		if ( '' !== $max_width_tablet || '' !== $max_width_phone || '' !== $max_width ) {

			$max_width_responsive_active = et_pb_get_responsive_status( $max_width_last_edited );

			$max_width_values = array(

				'desktop' => $max_width,

				'tablet'  => $max_width_responsive_active ? $max_width_tablet : '',

				'phone'   => $max_width_responsive_active ?  $max_width_phone : '',

			);





			$additional_css = ' !important;';



			et_pb_generate_responsive_css( $max_width_values, '%%order_class%% .header-content', 'max-width', $function_name, $additional_css );

		}



		if ( '' !== $title_font_color ) {

			ET_Builder_Element::set_style( $function_name, array(

				'selector'    => '%%order_class%%.et_pb_fullwidth_header .header-content h1',

				'declaration' => sprintf(

					'color: %1$s !important;',

					esc_html( $title_font_color )

				),

			) );

		}



		if ( '' !== $subhead_font_color ) {

			ET_Builder_Element::set_style( $function_name, array(

				'selector'    => '%%order_class%%.et_pb_fullwidth_header .et_pb_fullwidth_header_subhead',

				'declaration' => sprintf(

					'color: %1$s !important;',

					esc_html( $subhead_font_color )

				),

			) );

		}



		if ( '' !== $content_font_color ) {

			ET_Builder_Element::set_style( $function_name, array(

				'selector'    => '%%order_class%%.et_pb_fullwidth_header p',

				'declaration' => sprintf(

					'color: %1$s !important;',

					esc_html( $content_font_color )

				),

			) );

		}



		if ( '' !== $scroll_down_icon_color ) {

			ET_Builder_Element::set_style( $function_name, array(

				'selector'    => '%%order_class%%.et_pb_fullwidth_header .et_pb_fullwidth_header_scroll a .et-pb-icon',

				'declaration' => sprintf(

					'color: %1$s;',

					esc_html( $scroll_down_icon_color )

				),

			) );

		}



		if ( '' !== $scroll_down_icon_size || '' !== $scroll_down_icon_size_tablet || '' !== $scroll_down_icon_size_phone ) {

			$icon_size_responsive_active = et_pb_get_responsive_status( $scroll_down_icon_size_last_edited );



			$icon_size_values = array(

				'desktop' => $scroll_down_icon_size,

				'tablet'  => $icon_size_responsive_active ? $scroll_down_icon_size_tablet : '',

				'phone'   => $icon_size_responsive_active ? $scroll_down_icon_size_phone : '',

			);



			et_pb_generate_responsive_css( $icon_size_values, '%%order_class%%.et_pb_fullwidth_header .et_pb_fullwidth_header_scroll a .et-pb-icon', 'font-size', $function_name );

		}



		if ( '' !== $background_color ) {

			ET_Builder_Element::set_style( $function_name, array(

				'selector'    => '%%order_class%%.et_pb_fullwidth_header',

				'declaration' => sprintf(

					'background-color: %1$s;',

					esc_html( $background_color )

				),

			) );

		}



		if ( '' !== $background_overlay_color ) {

			ET_Builder_Element::set_style( $function_name, array(

				'selector'    => '%%order_class%%.et_pb_fullwidth_header .et_pb_fullwidth_header_overlay',

				'declaration' => sprintf(

					'background-color: %1$s;',

					esc_html( $background_overlay_color )

				),

			) );

		}



		if ( '' !== $background_url && 'off' === $parallax ) {

			ET_Builder_Element::set_style( $function_name, array(

				'selector'    => '%%order_class%%.et_pb_fullwidth_header',

				'declaration' => sprintf(

					'background-image: url(%1$s);',

					esc_url( $background_url )

				),

			) );

		}



		$button_output = '';

		if ( '' !== $button_one_text ) {

			$button_output .= sprintf(

				'<a href="%2$s" class="et_pb_more_button et_pb_button et_pb_button_one%4$s"%3$s>%1$s</a>',

				( '' !== $button_one_text ? esc_attr( $button_one_text ) : '' ),

				( '' !== $button_one_url ? esc_url( $button_one_url ) : '#' ),

				'' !== $custom_icon_1 && 'on' === $button_custom_1 ? sprintf(

					' data-icon="%1$s"',

					esc_attr( et_pb_process_font_icon( $custom_icon_1 ) )

				) : '',

				'' !== $custom_icon_1 && 'on' === $button_custom_1 ? ' et_pb_custom_button_icon' : ''

			);

		}



		if ( '' !== $button_two_text ) {

			$button_output .= sprintf(

				'<a href="%2$s" class="et_pb_more_button et_pb_button et_pb_button_two%4$s"%3$s>%1$s</a>',

				( '' !== $button_two_text ? esc_attr( $button_two_text ) : '' ),

				( '' !== $button_two_url ? esc_url( $button_two_url ) : '#' ),

				'' !== $custom_icon_2 && 'on' === $button_custom_2 ? sprintf(

					' data-icon="%1$s"',

					esc_attr( et_pb_process_font_icon( $custom_icon_2 ) )

				) : '',

				'' !== $custom_icon_2 && 'on' === $button_custom_2 ? ' et_pb_custom_button_icon' : ''

			);

		}



		$class = " et_pb_module et_pb_bg_layout_{$background_layout} et_pb_text_align_{$text_orientation}";



		$header_content = '';

		if ( '' !== $title || '' !== $subhead || '' !== $content || '' !== $button_output || '' !== $logo_image_url ) {

			$logo_image = '';

			if ( '' !== $logo_image_url ){

				$logo_image = sprintf(

					'<img src="%1$s" alt="%2$s"%3$s />',

					esc_url( $logo_image_url ),

					esc_attr( $logo_alt_text ),

					( '' !== $logo_title ? sprintf( ' title="%1$s"', esc_attr( $logo_title ) ) : '' )

				);

			}

			$header_content = sprintf(

				'<div class="header-content-container%6$s">

					<div class="header-content">

						%3$s

						%1$s

						%2$s

						%4$s

						%5$s

					</div>

				</div>',

				( $title ? sprintf( '<h1>%1$s</h1>', $title ) : '' ),

				( $subhead ? sprintf( '<span class="et_pb_fullwidth_header_subhead">%1$s</span>', $subhead ) : '' ),

				$logo_image,

				$this->shortcode_content,

				( '' !== $button_output ? $button_output : '' ),

				( '' !== $content_orientation ? sprintf( ' %1$s', $content_orientation ) : '' )

			);

		}



		$header_image = '';

		if ( '' !== $header_image_url ) {

			$header_image = sprintf(

				'<div class="header-image-container%2$s">

					<div class="header-image">

						<img src="%1$s" />

					</div>

				</div>',

				( '' !== $header_image_url ? esc_url( $header_image_url ) : ''),

				( '' !== $image_orientation ? sprintf( ' %1$s', $image_orientation ) : '' )

			);



			$module_class .= ' et_pb_header_with_image';



		}



		$scroll_down_output = '';

		if ( 'off' !== $header_scroll_down || '' !== $scroll_down_icon ) {

			$scroll_down_output .= sprintf(

				'<a href="#"><span class="scroll-down et-pb-icon">%1$s</span></a>',

				esc_html( et_pb_process_font_icon( $scroll_down_icon, 'et_pb_get_font_down_icon_symbols' ) )

			);

		}



        ob_start();

        ?>

            <script type="text/javascript">

                jQuery('document').ready(function(){

                    var kontrola = jQuery('.kontrola');

                    

                    kontrola.each(function(){

                    

                        var specify = jQuery(this).val();

                        

                        var obrazky = jQuery('.slider_image'+specify);

                        var pocetObrazku = obrazky.length;

                        var pocetObrazkuKontola = pocetObrazku - 1;

                        var urlObrazku = [];  

                        var i=0;

                        var parallaxKontrola = jQuery('#sliderheaderparallax' + specify).length;

                        var sliderLocation = '';

                        

                        if(parallaxKontrola > 0){

                            sliderLocation = jQuery('#sliderheaderparallax' + specify);

                        }else{

                            sliderLocation = jQuery('#sliderheader' + specify);

                        }

                        

                        if(pocetObrazku > 1 ){

                            obrazky.each(function(e){

                                urlObrazku[e] = jQuery(this).val();

                            });



                            setInterval(function() {

                                switch(i++%pocetObrazku) {

                                    case 0:

                                        sliderLocation.fadeTo('slow', 0.3, function()

                                        {

                                            jQuery(this).css('background-image', 'url(' + urlObrazku[1] + ')');

                                        }).fadeTo('slow', 1);

                                    break;

                                    case 1: 

                                        sliderLocation.fadeTo('slow', 0.3, function()

                                        {

                                            if(pocetObrazku == 2){

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[0] + ')');

                                            }else{

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[2] + ')');

                                            }    

                                        }).fadeTo('slow', 1);

                                    break;

                                    case 2: 

                                        sliderLocation.fadeTo('slow', 0.3, function()

                                        {

                                            if(pocetObrazku == 3){

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[0] + ')');

                                            }else{

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[3] + ')');

                                            }    

                                        }).fadeTo('slow', 1);

                                    break;

                                    case 3: 

                                        sliderLocation.fadeTo('slow', 0.3, function()

                                        {

                                            if(pocetObrazku == 4){

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[0] + ')');

                                            }else{

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[4] + ')');

                                            }    

                                        }).fadeTo('slow', 1);

                                    break;

                                    case 4: 

                                        sliderLocation.fadeTo('slow', 0.3, function()

                                        {

                                            if(pocetObrazku == 5){

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[0] + ')');

                                            }else{

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[5] + ')');

                                            }    

                                        }).fadeTo('slow', 1);

                                    break;

                                    case 5: 

                                        sliderLocation.fadeTo('slow', 0.3, function()

                                        {

                                            if(pocetObrazku == 6){

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[0] + ')');

                                            }else{

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[6] + ')');

                                            }    

                                        }).fadeTo('slow', 1);

                                    break;

                                    case 6: 

                                        sliderLocation.fadeTo('slow', 0.3, function()

                                        {

                                            if(pocetObrazku == 7){

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[0] + ')');

                                            }else{

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[7] + ')');

                                            }    

                                        }).fadeTo('slow', 1);

                                    break;

                                    case 7: 

                                        sliderLocation.fadeTo('slow', 0.3, function()

                                        {

                                            if(pocetObrazku == 8){

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[0] + ')');

                                            }else{

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[8] + ')');

                                            }    

                                        }).fadeTo('slow', 1);

                                    break;

                                    case 8: 

                                        sliderLocation.fadeTo('slow', 0.3, function()

                                        {

                                            if(pocetObrazku == 9){

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[0] + ')');

                                            }else{

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[9] + ')');

                                            }    

                                        }).fadeTo('slow', 1);

                                    break;

                                    case 9: 

                                        sliderLocation.fadeTo('slow', 0.3, function()

                                        {

                                            if(pocetObrazku == 10){

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[0] + ')');

                                            }else{

                                                jQuery(this).css('background-image', 'url(' + urlObrazku[10] + ')');

                                            }    

                                        }).fadeTo('slow', 1);

                                    break;

                                    case 10: 

                                        sliderLocation.fadeTo('slow', 0.3, function()

                                        {

                                            jQuery(this).css('background-image', 'url(' + urlObrazku[0] + ')');

                                        }).fadeTo('slow', 1);

                                    break;

                                }



                            }, <?php if($background_animation_speed !== ''){echo ($background_animation_speed * 1000);}else{ echo 10000; } ?>);

                             





                        }

                    

                    });    

                        

                });

            </script>

        <?php

        if( 'on' === $background_slider_on){

            $slider_custom_script = ob_get_contents();

        }else{

            $slider_custom_script = '';

        }

       ob_end_clean();

        $kontrola = rand(0,100);

		$output = sprintf(

			'<section%9$s class="et_pb_fullwidth_header%1$s%7$s%8$s%10$s" id="sliderheader%23$s">

				%6$s

                ' . ('on' === $background_slider_on ? '%11$s

                %12$s

                %13$s

                %14$s 

                %15$s

                %16$s

                %17$s

                %18$s

                %19$s

                %20$s

                %21$s

                %22$s' : '' ) . '

				<div class="et_pb_fullwidth_header_container%5$s">

					%2$s

					%3$s

				</div>

				<div class="et_pb_fullwidth_header_overlay"></div>

				<div class="et_pb_fullwidth_header_scroll">%4$s</div>

			</section>',

			( 'off' !== $header_fullscreen ? ' et_pb_fullscreen' : '' ),

			( '' !== $header_content ? $header_content : '' ),

			( '' !== $header_image ? $header_image : '' ),

			( 'off' !== $header_scroll_down ? $scroll_down_output : '' ),

			( '' !== $text_orientation ? sprintf( ' %1$s', esc_attr( $text_orientation ) ) : '' ),

			( '' !== $background_url && 'on' === $parallax

				? sprintf(

					'<div class="et_parallax_bg%2$s" style="background-image: url(%1$s);" id="sliderheaderparallax' . $kontrola . '"></div>',

					esc_attr( $background_url ),

					( 'off' === $parallax_method ? ' et_pb_parallax_css' : '' )

				)

				: ''

			),

			( '' !== $background_url && 'on' === $parallax ? ' et_pb_section_parallax' : '' ),

			esc_attr( $class ),

			( '' !== $module_id ? sprintf( ' id="%1$s"', esc_attr( $module_id ) ) : '' ),

			( '' !== $module_class ? sprintf( ' %1$s', esc_attr( $module_class ) ) : '' ),

			( '' !== $background_url ? '<input type="hidden" class="slider_image' . $kontrola . '" value="' . $background_url . '" />' : '' ),

			( '' !== $background_url2 ? '<input type="hidden" class="slider_image' . $kontrola . '" value="' . $background_url2 . '" />' : '' ),

			( '' !== $background_url3 ? '<input type="hidden" class="slider_image' . $kontrola . '" value="' . $background_url3 . '" />' : '' ),

			( '' !== $background_url4 ? '<input type="hidden" class="slider_image' . $kontrola . '" value="' . $background_url4 . '" />' : '' ),

			( '' !== $background_url5 ? '<input type="hidden" class="slider_image' . $kontrola . '" value="' . $background_url5 . '" />' : '' ),

			( '' !== $background_url6 ? '<input type="hidden" class="slider_image' . $kontrola . '" value="' . $background_url6 . '" />' : '' ),

			( '' !== $background_url7 ? '<input type="hidden" class="slider_image' . $kontrola . '" value="' . $background_url7 . '" />' : '' ),

			( '' !== $background_url8 ? '<input type="hidden" class="slider_image' . $kontrola . '" value="' . $background_url8 . '" />' : '' ),

			( '' !== $background_url9 ? '<input type="hidden" class="slider_image' . $kontrola . '" value="' . $background_url9 . '" />' : '' ),

			( '' !== $background_url10 ? '<input type="hidden" class="slider_image' . $kontrola . '" value="' . $background_url10 . '" />' : '' ),

			( '' !== $slider_custom_script ? $slider_custom_script : '' ),

			'<input type="hidden" class="kontrola" value="' . $kontrola . '" />',

            $kontrola

		);



		return $output;

	}

}

new ET_Builder_Module_Fullwidth_Header_slide;



class ET_Builder_Module_Blog_lama extends ET_Builder_Module {

	function init() {

		$this->name       = esc_html__( 'Lama - Blog', 'et_builder' );

		$this->slug       = 'et_pb_blog_lama7';

		$this->fb_support = true;



		$this->whitelisted_fields = array(

			'fullwidth',

			'posts_number',

			'include_categories',

			'meta_date',

			'same_height', 

			'show_thumbnail',

			'show_content_on',

			'show_content',

			'show_more',

			'read_more_text',

			'more_align',

			'show_author',

			'show_date',

			'show_categories',

			'show_comments', 

			'show_pagination',

			'offset_number',

			'background_layout',

			'admin_label',

			'module_id',

			'module_class',

			'masonry_tile_background_color',

			'use_dropshadow',

			'use_overlay',

			'overlay_icon_color',

			'hover_overlay_color',

			'hover_icon',

		);



		$this->fields_defaults = array(

			'fullwidth'         => array( 'on' ),

			'posts_number'      => array( 10, 'add_default_setting' ),

			'meta_date'         => array( 'M j, Y', 'add_default_setting' ),

			'show_thumbnail'    => array( 'on' ),

			'show_content'      => array( 'off' ),

			'show_content_on'   => array( 'on' ),

			'show_more'         => array( 'off' ),

			'more_align'         => array( 'on' ),

			'show_author'       => array( 'on' ),

			'show_date'         => array( 'on' ),

			'show_categories'   => array( 'on' ),

			'show_comments'     => array( 'off' ),

			'show_pagination'   => array( 'on' ),

			'offset_number'     => array( 0, 'only_default_setting' ),

			'background_layout' => array( 'light' ),

			'use_dropshadow'    => array( 'off' ),

			'use_overlay'       => array( 'off' ),

		);



		$this->main_css_element = '%%order_class%% .et_pb_post';

		$this->advanced_options = array(

			'fonts' => array(

				'header' => array(

					'label'    => esc_html__( 'Header', 'et_builder' ),

					'css'      => array(

						'main' => "{$this->main_css_element} .entry-title",

						'plugin_main' => "{$this->main_css_element} .entry-title, {$this->main_css_element} .entry-title a",

						'important' => 'all',

					),

				),

				'meta' => array(

					'label'    => esc_html__( 'Meta', 'et_builder' ),

					'css'      => array(

						'main'        => "{$this->main_css_element} .post-meta, {$this->main_css_element} .post-meta a",

						'plugin_main' => "{$this->main_css_element} .post-meta, {$this->main_css_element} .post-meta a, {$this->main_css_element} .post-meta span",

					),

				),

				'body'   => array(

					'label'    => esc_html__( 'Body', 'et_builder' ),

					'css'      => array(

						'main'        => "{$this->main_css_element}, %%order_class%%.et_pb_bg_layout_light .et_pb_post .post-content p, %%order_class%%.et_pb_bg_layout_dark .et_pb_post .post-content p",

						'color'       => "{$this->main_css_element}, {$this->main_css_element} .post-content *",

						'line_height' => "{$this->main_css_element} p",

					),

				),

			),

			'border' => array(

				'css'      => array(

					'main' => "%%order_class%%.et_pb_module .et_pb_post",

					'important' => 'plugin_only',

				),

			),

		);

		$this->custom_css_options = array(

			'title' => array(

				'label'    => esc_html__( 'Title', 'et_builder' ),

				'selector' => '.et_pb_post .entry-title',

			),

			'post_meta' => array(

				'label'    => esc_html__( 'Post Meta', 'et_builder' ),

				'selector' => '.et_pb_post .post-meta',

			),

			'pagenavi' => array(

				'label'    => esc_html__( 'Pagenavi', 'et_builder' ),

				'selector' => '.wp_pagenavi',

			),

			'featured_image' => array(

				'label'    => esc_html__( 'Featured Image', 'et_builder' ),

				'selector' => '.et_pb_image_container',

			),

			'read_more' => array(

				'label'    => esc_html__( 'Read More Button', 'et_builder' ),

				'selector' => '.et_pb_post .more-link',

			),

		);

	}



	function get_fields() {

		$fields = array(

			'fullwidth' => array(

				'label'             => esc_html__( 'Layout', 'et_builder' ),

				'type'              => 'select',

				'option_category'   => 'layout',

				'options'           => array(

					'on'  => esc_html__( 'Fullwidth', 'et_builder' ),

					'off' => esc_html__( 'Grid', 'et_builder' ),

				),

				'affects'           => array(

					'background_layout',

					'use_dropshadow',

					'masonry_tile_background_color',

					'same_height',

				),

				'description'        => esc_html__( 'Toggle between the various blog layout types.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'posts_number' => array(

				'label'             => esc_html__( 'Posts Number', 'et_builder' ),

				'type'              => 'text',

				'option_category'   => 'configuration',

				'description'       => esc_html__( 'Choose how much posts you would like to display per page.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'include_categories' => array(

				'label'            => esc_html__( 'Include Categories', 'et_builder' ),

				'renderer'         => 'et_builder_include_categories_option',

				'option_category'  => 'basic_option',

				'renderer_options' => array(

					'use_terms' => false,

				),

				'description'      => esc_html__( 'Choose which categories you would like to include in the feed.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'meta_date' => array(

				'label'             => esc_html__( 'Meta Date Format', 'et_builder' ),

				'type'              => 'text',

				'option_category'   => 'configuration',

				'description'       => esc_html__( 'If you would like to adjust the date format, input the appropriate PHP date format here.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'same_height' => array(

				'label'             => esc_html__( 'Same height', 'et_builder' ),

				'type'              => 'yes_no_button',

				'option_category'   => 'configuration',

				'options'           => array(

					'off' => esc_html__( 'Off', 'et_builder' ),

					'on'  => esc_html__( 'On', 'et_builder' ),

				),

				'depends_show_if'   => 'off',

				'description'       => esc_html__( 'All posts have same height.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'show_thumbnail' => array(

				'label'             => esc_html__( 'Show Featured Image', 'et_builder' ),

				'type'              => 'yes_no_button',

				'option_category'   => 'configuration',

				'options'           => array(

					'on'  => esc_html__( 'Yes', 'et_builder' ),

					'off' => esc_html__( 'No', 'et_builder' ),

				),

				'description'        => esc_html__( 'This will turn thumbnails on and off.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'show_content_on' => array(

				'label'             => esc_html__( 'Show content', 'et_builder' ),

				'type'              => 'yes_no_button',

				'option_category'   => 'configuration',

				'options'           => array(

					'on'  => esc_html__( 'Yes', 'et_builder' ),

					'off' => esc_html__( 'No', 'et_builder' ),

				),

				'description'        => esc_html__( 'This will turn content on and off.', 'et_builder' ),

				'affects'   => array(

					'show_content',

				),

			),

			'show_content' => array(

				'label'             => esc_html__( 'Content', 'et_builder' ),

				'type'              => 'select',

				'option_category'   => 'configuration',

				'options'           => array(

					'off' => esc_html__( 'Show Excerpt', 'et_builder' ),

					'on'  => esc_html__( 'Show Content', 'et_builder' ),

				),

				'depends_show_if'   => 'on',

				'affects'           => array(

					'show_more',

				),

				'description'        => esc_html__( 'Showing the full content will not truncate your posts on the index page. Showing the excerpt will only display your excerpt text.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'show_more' => array(

				'label'             => esc_html__( 'Read More Button', 'et_builder' ),

				'type'              => 'yes_no_button',

				'option_category'   => 'configuration',

				'options'           => array(

					'off' => esc_html__( 'Off', 'et_builder' ),

					'on'  => esc_html__( 'On', 'et_builder' ),

				),

				'depends_show_if'   => 'off',

				'description'       => esc_html__( 'Here you can define whether to show "read more" link after the excerpts or not.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

				'affects'   => array(

					'more_align',

					'read_more_text',

				),

			),

			'read_more_text' => array(

				'label'             => esc_html__( 'Read more text', 'et_builder' ),

				'type'              => 'text',

				'option_category'   => 'configuration',

				'description'       => esc_html__( 'Default: read more', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

				'depends_show_if'   => 'on',

			),

			'more_align' => array(

				'label'             => esc_html__( 'Read more align', 'et_builder' ),

				'type'              => 'select',

				'option_category'   => 'layout',

				'options'           => array(

					'on'  => esc_html__( 'Left', 'et_builder' ),

					'off' => esc_html__( 'Right', 'et_builder' ),

				),

				'description'        => esc_html__( 'Read more text align.', 'et_builder' ),

				'depends_show_if'   => 'on',

			),

			'show_author' => array(

				'label'             => esc_html__( 'Show Author', 'et_builder' ),

				'type'              => 'yes_no_button',

				'option_category'   => 'configuration',

				'options'           => array(

					'on'  => esc_html__( 'Yes', 'et_builder' ),

					'off' => esc_html__( 'No', 'et_builder' ),

				),

				'description'        => esc_html__( 'Turn on or off the author link.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'show_date' => array(

				'label'             => esc_html__( 'Show Date', 'et_builder' ),

				'type'              => 'yes_no_button',

				'option_category'   => 'configuration',

				'options'           => array(

					'on'  => esc_html__( 'Yes', 'et_builder' ),

					'off' => esc_html__( 'No', 'et_builder' ),

				),

				'description'        => esc_html__( 'Turn the date on or off.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'show_categories' => array(

				'label'             => esc_html__( 'Show Categories', 'et_builder' ),

				'type'              => 'yes_no_button',

				'option_category'   => 'configuration',

				'options'           => array(

					'on'  => esc_html__( 'Yes', 'et_builder' ),

					'off' => esc_html__( 'No', 'et_builder' ),

				),

				'description'        => esc_html__( 'Turn the category links on or off.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'show_comments' => array(

				'label'             => esc_html__( 'Show Comment Count', 'et_builder' ),

				'type'              => 'yes_no_button',

				'option_category'   => 'configuration',

				'options'           => array(

					'on'  => esc_html__( 'Yes', 'et_builder' ),

					'off' => esc_html__( 'No', 'et_builder' ),

				),

				'description'        => esc_html__( 'Turn comment count on and off.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'show_pagination' => array(

				'label'             => esc_html__( 'Show Pagination', 'et_builder' ),

				'type'              => 'yes_no_button',

				'option_category'   => 'configuration',

				'options'           => array(

					'on'  => esc_html__( 'Yes', 'et_builder' ),

					'off' => esc_html__( 'No', 'et_builder' ),

				),

				'description'        => esc_html__( 'Turn pagination on and off.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'offset_number' => array(

				'label'           => esc_html__( 'Offset Number', 'et_builder' ),

				'type'            => 'text',

				'option_category' => 'configuration',

				'description'     => esc_html__( 'Choose how many posts you would like to offset by', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'use_overlay' => array(

				'label'             => esc_html__( 'Featured Image Overlay', 'et_builder' ),

				'type'              => 'yes_no_button',

				'option_category'   => 'layout',

				'options'           => array(

					'off' => esc_html__( 'Off', 'et_builder' ),

					'on'  => esc_html__( 'On', 'et_builder' ),

				),

				'affects'           => array(

					'overlay_icon_color',

					'hover_overlay_color',

					'hover_icon',

				),

				'description'       => esc_html__( 'If enabled, an overlay color and icon will be displayed when a visitors hovers over the featured image of a post.', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'overlay_icon_color' => array(

				'label'             => esc_html__( 'Overlay Icon Color', 'et_builder' ),

				'type'              => 'color',

				'custom_color'      => true,

				'depends_show_if'   => 'on',

				'description'       => esc_html__( 'Here you can define a custom color for the overlay icon', 'et_builder' ),

			),

			'hover_overlay_color' => array(

				'label'             => esc_html__( 'Hover Overlay Color', 'et_builder' ),

				'type'              => 'color-alpha',

				'custom_color'      => true,

				'depends_show_if'   => 'on',

				'description'       => esc_html__( 'Here you can define a custom color for the overlay', 'et_builder' ),

			),

			'hover_icon' => array(

				'label'               => esc_html__( 'Hover Icon Picker', 'et_builder' ),

				'type'                => 'text',

				'option_category'     => 'configuration',

				'class'               => array( 'et-pb-font-icon' ),

				'renderer'            => 'et_pb_get_font_icon_list',

				'renderer_with_field' => true,

				'depends_show_if'     => 'on',

				'description'         => esc_html__( 'Here you can define a custom icon for the overlay', 'et_builder' ),

				'computed_affects'   => array(

					'__posts',

				),

			),

			'background_layout' => array(

				'label'       => esc_html__( 'Text Color', 'et_builder' ),

				'type'        => 'select',

				'option_category' => 'color_option',

				'options'           => array(

					'light' => esc_html__( 'Dark', 'et_builder' ),

					'dark'  => esc_html__( 'Light', 'et_builder' ),

				),

				'depends_default' => true,

				'description' => esc_html__( 'Here you can choose whether your text should be light or dark. If you are working with a dark background, then your text should be light. If your background is light, then your text should be set to dark.', 'et_builder' ),

			),

			'masonry_tile_background_color' => array(

				'label'             => esc_html__( 'Grid Tile Background Color', 'et_builder' ),

				'type'              => 'color-alpha',

				'custom_color'      => true,

				'tab_slug'          => 'advanced',

				'depends_show_if'   => 'off',

				'depends_to'        => array(

					'fullwidth'

				),

			),

			'use_dropshadow' => array(

				'label'             => esc_html__( 'Use Dropshadow', 'et_builder' ),

				'type'              => 'yes_no_button',

				'option_category'   => 'layout',

				'options'           => array(

					'off' => esc_html__( 'Off', 'et_builder' ),

					'on'  => esc_html__( 'On', 'et_builder' ),

				),

				'tab_slug'          => 'advanced',

				'depends_show_if'   => 'off',

				'depends_to'        => array(

					'fullwidth'

				),

			),

			'disabled_on' => array(

				'label'           => esc_html__( 'Disable on', 'et_builder' ),

				'type'            => 'multiple_checkboxes',

				'options'         => array(

					'phone'   => esc_html__( 'Phone', 'et_builder' ),

					'tablet'  => esc_html__( 'Tablet', 'et_builder' ),

					'desktop' => esc_html__( 'Desktop', 'et_builder' ),

				),

				'additional_att'  => 'disable_on',

				'option_category' => 'configuration',

				'description'     => esc_html__( 'This will disable the module on selected devices', 'et_builder' ),

			),

			'admin_label' => array(

				'label'       => esc_html__( 'Admin Label', 'et_builder' ),

				'type'        => 'text',

				'description' => esc_html__( 'This will change the label of the module in the builder for easy identification.', 'et_builder' ),

			),

			'module_id' => array(

				'label'           => esc_html__( 'CSS ID', 'et_builder' ),

				'type'            => 'text',

				'option_category' => 'configuration',

				'tab_slug'        => 'custom_css',

				'option_class'    => 'et_pb_custom_css_regular',

			),

			'module_class' => array(

				'label'           => esc_html__( 'CSS Class', 'et_builder' ),

				'type'            => 'text',

				'option_category' => 'configuration',

				'tab_slug'        => 'custom_css',

				'option_class'    => 'et_pb_custom_css_regular',

			),

			'__posts' => array(

				'type' => 'computed',

				'computed_callback' => array( 'ET_Builder_Module_Blog', 'get_blog_posts' ),

				'computed_depends_on' => array(

					'fullwidth',

					'posts_number',

					'include_categories',

					'meta_date',

					'show_thumbnail',

					'show_content',

					'show_more',

					'show_author',

					'show_date',

					'show_categories',

					'show_comments',

					'show_pagination',

					'offset_number',

					'use_overlay',

					'hover_icon',

				),

			),

		);

		return $fields;

	}



	/**

	 * Get blog posts for blog module

	 *

	 * @param array   arguments that is being used by et_pb_blog

	 * @return string blog post markup

	 */

	static function get_blog_posts( $args = array(), $conditional_tags = array(), $current_page = array() ) {

		global $paged, $post, $wp_query, $et_fb_processing_shortcode_object, $et_pb_rendering_column_content;



		$global_processing_original_value = $et_fb_processing_shortcode_object;



		// Default params are combination of attributes that is used by et_pb_blog and

		// conditional tags that need to be simulated (due to AJAX nature) by passing args

		$defaults = array(

			'fullwidth'                     => '',

			'posts_number'                  => '',

			'include_categories'            => '',

			'meta_date'                     => '',

			'show_thumbnail'                => '',

			'show_content'                  => '',

			'show_author'                   => '',

			'show_date'                     => '',

			'show_categories'               => '',

			'show_comments'                 => '',

			'show_pagination'               => '',

			'background_layout'             => '',

			'show_more'                     => '',

			'offset_number'                 => '',

			'masonry_tile_background_color' => '',

			'use_dropshadow'                => '',

			'overlay_icon_color'            => '',

			'hover_overlay_color'           => '',

			'hover_icon'                    => '',

			'use_overlay'                   => '',

		);



		// WordPress' native conditional tag is only available during page load. It'll fail during component update because

		// et_pb_process_computed_property() is loaded in admin-ajax.php. Thus, use WordPress' conditional tags on page load and

		// rely to passed $conditional_tags for AJAX call

		$is_front_page               = et_fb_conditional_tag( 'is_front_page', $conditional_tags );

		$is_search                   = et_fb_conditional_tag( 'is_search', $conditional_tags );

		$is_single                   = et_fb_conditional_tag( 'is_single', $conditional_tags );

		$et_is_builder_plugin_active = et_fb_conditional_tag( 'et_is_builder_plugin_active', $conditional_tags );



		$container_is_closed = false;



		// remove all filters from WP audio shortcode to make sure current theme doesn't add any elements into audio module

		remove_all_filters( 'wp_audio_shortcode_library' );

		remove_all_filters( 'wp_audio_shortcode' );

		remove_all_filters( 'wp_audio_shortcode_class');



		$args = wp_parse_args( $args, $defaults );



		$overlay_output = '';

		$hover_icon = '';



		if ( 'on' === $args['use_overlay'] ) {

			$data_icon = '' !== $args['hover_icon']

				? sprintf(

					' data-icon="%1$s"',

					esc_attr( et_pb_process_font_icon( $args['hover_icon'] ) )

				)

				: '';



			$overlay_output = sprintf(

				'<span class="et_overlay%1$s"%2$s></span>',

				( '' !== $args['hover_icon'] ? ' et_pb_inline_icon' : '' ),

				$data_icon

			);

		}



		$overlay_class = 'on' === $args['use_overlay'] ? ' et_pb_has_overlay' : '';



		$query_args = array(

			'posts_per_page' => intval( $args['posts_number'] ),

			'post_status'    => 'publish',

		);



		if ( defined( 'DOING_AJAX' ) && isset( $current_page[ 'paged'] ) ) {

			$paged = intval( $current_page[ 'paged' ] );

		} else {

			$paged = $is_front_page ? get_query_var( 'page' ) : get_query_var( 'paged' );

		}



		if ( '' !== $args['include_categories'] ) {

			$query_args['cat'] = $args['include_categories'];

		}



		if ( ! $is_search ) {

			$query_args['paged'] = $paged;

		}



		if ( '' !== $args['offset_number'] && ! empty( $args['offset_number'] ) ) {

			/**

			 * Offset + pagination don't play well. Manual offset calculation required

			 * @see: https://codex.wordpress.org/Making_Custom_Queries_using_Offset_and_Pagination

			 */

			if ( $paged > 1 ) {

				$query_args['offset'] = ( ( $paged - 1 ) * intval( $args['posts_number'] ) ) + intval( $args['offset_number'] );

			} else {

				$query_args['offset'] = intval( $args['offset_number'] );

			}

		}



		if ( $is_single ) {

			$query_args['post__not_in'][] = get_the_ID();

		}



		// Get query

		$query = new WP_Query( $query_args );



		// Keep page's $wp_query global

		$wp_query_page = $wp_query;



		// Turn page's $wp_query into this module's query

		$wp_query = $query;



		ob_start();



		if ( $query->have_posts() ) {



			while( $query->have_posts() ) {

				$query->the_post();

				global $et_fb_processing_shortcode_object;



				$global_processing_original_value = $et_fb_processing_shortcode_object;



				// reset the fb processing flag

				$et_fb_processing_shortcode_object = false;



				$thumb          = '';

				$width          = 'on' === $args['fullwidth'] ? 1080 : 400;

				$width          = (int) apply_filters( 'et_pb_blog_image_width', $width );

				$height         = 'on' === $args['fullwidth'] ? 675 : 250;

				$height         = (int) apply_filters( 'et_pb_blog_image_height', $height );

				$classtext      = 'on' === $args['fullwidth'] ? 'et_pb_post_main_image' : '';

				$titletext      = get_the_title();

				$thumbnail      = get_thumbnail( $width, $height, $classtext, $titletext, $titletext, false, 'Blogimage' );

				$thumb          = $thumbnail["thumb"];

				$no_thumb_class = '' === $thumb || 'off' === $args['show_thumbnail'] ? ' et_pb_no_thumb' : '';



				$post_format = et_pb_post_format();

				if ( in_array( $post_format, array( 'video', 'gallery' ) ) ) {

					$no_thumb_class = '';

				}



				// Print output

				?>

					<article id="" <?php post_class( 'et_pb_post clearfix' . $no_thumb_class . $overlay_class ) ?>>

						<?php

							et_divi_post_format_content();



							if ( ! in_array( $post_format, array( 'link', 'audio', 'quote' ) ) ) {

								if ( 'video' === $post_format && false !== ( $first_video = et_get_first_video() ) ) :

									$video_overlay = has_post_thumbnail() ? sprintf(

										'<div class="et_pb_video_overlay" style="background-image: url(%1$s); background-size: cover;">

											<div class="et_pb_video_overlay_hover">

												<a href="#" class="et_pb_video_play"></a>

											</div>

										</div>',

										$thumb

									) : '';



									printf(

										'<div class="et_main_video_container">

											%1$s

											%2$s

										</div>',

										$video_overlay,

										$first_video

									);

								elseif ( 'gallery' === $post_format ) :

									et_pb_gallery_images( 'slider' );

								elseif ( '' !== $thumb && 'on' === $args['show_thumbnail'] ) :

									if ( 'on' !== $args['fullwidth'] ) echo '<div class="et_pb_image_container">'; ?>

										<a href="<?php esc_url( the_permalink() ); ?>" class="entry-featured-image-url">

											<?php print_thumbnail( $thumb, $thumbnail["use_timthumb"], $titletext, $width, $height ); ?>

											<?php if ( 'on' === $args['use_overlay'] ) {

												echo $overlay_output;

											} ?>

										</a>

								<?php

									if ( 'on' !== $args['fullwidth'] ) echo '</div> <!-- .et_pb_image_container -->';

								endif;

							}

						?>



						<?php if ( 'off' === $args['fullwidth'] || ! in_array( $post_format, array( 'link', 'audio', 'quote' ) ) ) { ?>

							<?php if ( ! in_array( $post_format, array( 'link', 'audio' ) ) ) { ?>

								<h2 class="entry-title"><a href="<?php esc_url( the_permalink() ); ?>"><?php the_title(); ?></a></h2>

							<?php } ?>



							<?php

								if ( 'on' === $args['show_author'] || 'on' === $args['show_date'] || 'on' === $args['show_categories'] || 'on' === $args['show_comments'] ) {

									printf( '<p class="post-meta">%1$s %2$s %3$s %4$s %5$s %6$s %7$s</p>',

										(

											'on' === $args['show_author']

												? et_get_safe_localization( sprintf( __( 'by %s', 'et_builder' ), '<span class="author vcard">' .  et_pb_get_the_author_posts_link() . '</span>' ) )

												: ''

										),

										(

											( 'on' === $args['show_author'] && 'on' === $args['show_date'] )

												? ' | '

												: ''

										),

										(

											'on' === $args['show_date']

												? et_get_safe_localization( sprintf( __( '%s', 'et_builder' ), '<span class="published">' . esc_html( get_the_date( $args['meta_date'] ) ) . '</span>' ) )

												: ''

										),

										(

											(( 'on' === $args['show_author'] || 'on' === $args['show_date'] ) && 'on' === $args['show_categories'] )

												? ' | '

												: ''

										),

										(

											'on' === $args['show_categories']

												? get_the_category_list(', ')

												: ''

										),

										(

											(( 'on' === $args['show_author'] || 'on' === $args['show_date'] || 'on' === $args['show_categories'] ) && 'on' === $args['show_comments'])

												? ' | '

												: ''

										),

										(

											'on' === $args['show_comments']

												? sprintf( esc_html( _nx( '1 Comment', '%s Comments', get_comments_number(), 'number of comments', 'et_builder' ) ), number_format_i18n( get_comments_number() ) )

												: ''

										)

									);

								}



								$post_content = et_strip_shortcodes( et_delete_post_first_video( get_the_content() ), true );



								// reset the fb processing flag

								$et_fb_processing_shortcode_object = false;

								// set the flag to indicate that we're processing internal content

								$et_pb_rendering_column_content = true;

								// reset all the attributes required to properly generate the internal styles

								ET_Builder_Element::clean_internal_modules_styles();



								echo '<div class="post-content">';



								if ( 'on' === $args['show_content'] ) {

									global $more;



									// page builder doesn't support more tag, so display the_content() in case of post made with page builder

									if ( et_pb_is_pagebuilder_used( get_the_ID() ) ) {

										$more = 1;



										echo apply_filters( 'the_content', $post_content );



									} else {

										$more = null;

										echo apply_filters( 'the_content', et_delete_post_first_video( get_the_content( esc_html__( 'read more...', 'et_builder' ) ) ) );

									}

								} else {

									if ( has_excerpt() ) {

										the_excerpt();

									} else {

										if ( '' !== $post_content ) {

											// set the $et_fb_processing_shortcode_object to false, to retrieve the content inside truncate_post() correctly

											$et_fb_processing_shortcode_object = false;

											echo wpautop( et_delete_post_first_video( strip_shortcodes( truncate_post( 270, false, '', true ) ) ) );

											// reset the $et_fb_processing_shortcode_object to its original value

											$et_fb_processing_shortcode_object = $global_processing_original_value;

										} else {

											echo '';

										}

									}

								}



								$et_fb_processing_shortcode_object = $global_processing_original_value;

								// retrieve the styles for the modules inside Blog content

								$internal_style = ET_Builder_Element::get_style( true );

								// reset all the attributes after we retrieved styles

								ET_Builder_Element::clean_internal_modules_styles( false );

								$et_pb_rendering_column_content = false;

								// append styles to the blog content

								if ( $internal_style ) {

									printf(

										'<style type="text/css" class="et_fb_blog_inner_content_styles">

											%1$s

										</style>',

										$internal_style

									);

								}



								echo '</div>';



								if ( 'on' !== $args['show_content'] ) {

									$more = 'on' == $args['show_more'] ? sprintf( ' <a href="%1$s" class="more-link" >%2$s</a>' , esc_url( get_permalink() ), esc_html__( 'read more', 'et_builder' ) )  : '';

									echo $more;

								}

								?>

						<?php } // 'off' === $fullwidth || ! in_array( $post_format, array( 'link', 'audio', 'quote', 'gallery' ?>

					</article>

				<?php



				$et_fb_processing_shortcode_object = $global_processing_original_value;

			} // endwhile



			if ( 'on' === $args['show_pagination'] && ! $is_search ) {

				// echo '</div> <!-- .et_pb_posts -->'; // @todo this causes closing tag issue



				$container_is_closed = true;



				if ( function_exists( 'wp_pagenavi' ) ) {

					wp_pagenavi( array(

						'query' => $query

					) );

				} else {

					if ( $et_is_builder_plugin_active ) {

						include( ET_BUILDER_PLUGIN_DIR . 'includes/navigation.php' );

					} else {

						get_template_part( 'includes/navigation', 'index' );

					}

				}

			}



			wp_reset_query();

		} else {

			if ( $et_is_builder_plugin_active ) {

				include( ET_BUILDER_PLUGIN_DIR . 'includes/no-results.php' );

			} else {

				get_template_part( 'includes/no-results', 'index' );

			}

		}



		wp_reset_postdata();



		// Reset $wp_query to its origin

		$wp_query = $wp_query_page;



		$posts = ob_get_contents();



		ob_end_clean();



		return $posts;

	}



	function shortcode_callback( $atts, $content = null, $function_name ) {

		/**

		 * Cached $wp_filter so it can be restored at the end of the callback.

		 * This is needed because this callback uses the_content filter / calls a function

		 * which uses the_content filter. WordPress doesn't support nested filter

		 */

		global $wp_filter;

		$wp_filter_cache = $wp_filter;



		$module_id           = $this->shortcode_atts['module_id'];

		$module_class        = $this->shortcode_atts['module_class'];

		$fullwidth           = $this->shortcode_atts['fullwidth'];

		$posts_number        = $this->shortcode_atts['posts_number'];

		$include_categories  = $this->shortcode_atts['include_categories'];

		$meta_date           = $this->shortcode_atts['meta_date'];

		$show_thumbnail      = $this->shortcode_atts['show_thumbnail'];

		$show_content        = $this->shortcode_atts['show_content'];

		$show_content_on        = $this->shortcode_atts['show_content_on'];

		$same_height        = $this->shortcode_atts['same_height'];

		$more_align        = $this->shortcode_atts['more_align'];

		$read_more_text        = $this->shortcode_atts['read_more_text'];

		$show_author         = $this->shortcode_atts['show_author'];

		$show_date           = $this->shortcode_atts['show_date'];

		$show_categories     = $this->shortcode_atts['show_categories'];

		$show_comments       = $this->shortcode_atts['show_comments'];

		$show_pagination     = $this->shortcode_atts['show_pagination'];

		$background_layout   = $this->shortcode_atts['background_layout'];

		$show_more           = $this->shortcode_atts['show_more'];

		$offset_number       = $this->shortcode_atts['offset_number'];

		$masonry_tile_background_color = $this->shortcode_atts['masonry_tile_background_color'];

		$use_dropshadow      = $this->shortcode_atts['use_dropshadow'];

		$overlay_icon_color  = $this->shortcode_atts['overlay_icon_color'];

		$hover_overlay_color = $this->shortcode_atts['hover_overlay_color'];

		$hover_icon          = $this->shortcode_atts['hover_icon'];

		$use_overlay         = $this->shortcode_atts['use_overlay'];



		global $paged;



		$module_class = ET_Builder_Element::add_module_order_class( $module_class, $function_name );



		$container_is_closed = false;



		// remove all filters from WP audio shortcode to make sure current theme doesn't add any elements into audio module

		remove_all_filters( 'wp_audio_shortcode_library' );

		remove_all_filters( 'wp_audio_shortcode' );

		remove_all_filters( 'wp_audio_shortcode_class');



		if ( '' !== $masonry_tile_background_color ) {

			ET_Builder_Element::set_style( $function_name, array(

				'selector'    => '%%order_class%%.et_pb_blog_grid .et_pb_post',

				'declaration' => sprintf(

					'background-color: %1$s;',

					esc_html( $masonry_tile_background_color )

				),

			) );

		}



		if ( '' !== $overlay_icon_color ) {

			ET_Builder_Element::set_style( $function_name, array(

				'selector'    => '%%order_class%% .et_overlay:before',

				'declaration' => sprintf(

					'color: %1$s !important;',

					esc_html( $overlay_icon_color )

				),

			) );

		}



		if ( '' !== $hover_overlay_color ) {

			ET_Builder_Element::set_style( $function_name, array(

				'selector'    => '%%order_class%% .et_overlay',

				'declaration' => sprintf(

					'background-color: %1$s;',

					esc_html( $hover_overlay_color )

				),

			) );

		}



		if ( 'on' === $use_overlay ) {

			$data_icon = '' !== $hover_icon

				? sprintf(

					' data-icon="%1$s"',

					esc_attr( et_pb_process_font_icon( $hover_icon ) )

				)

				: '';



			$overlay_output = sprintf(

				'<span class="et_overlay%1$s"%2$s></span>',

				( '' !== $hover_icon ? ' et_pb_inline_icon' : '' ),

				$data_icon

			);

		}



		$overlay_class = 'on' === $use_overlay ? ' et_pb_has_overlay' : '';



		if ( 'on' !== $fullwidth ){

			if ( 'on' === $use_dropshadow ) {

				$module_class .= ' et_pb_blog_grid_dropshadow';

			}



			wp_enqueue_script( 'salvattore' );



			$background_layout = 'light';

		}



		$args = array( 'posts_per_page' => (int) $posts_number );



		$et_paged = is_front_page() ? get_query_var( 'page' ) : get_query_var( 'paged' );



		if ( is_front_page() ) {

			$paged = $et_paged;

		}



		if ( '' !== $include_categories )

			$args['cat'] = $include_categories;



		if ( ! is_search() ) {

			$args['paged'] = $et_paged;

		}



		if ( '' !== $offset_number && ! empty( $offset_number ) ) {

			/**

			 * Offset + pagination don't play well. Manual offset calculation required

			 * @see: https://codex.wordpress.org/Making_Custom_Queries_using_Offset_and_Pagination

			 */

			if ( $paged > 1 ) {

				$args['offset'] = ( ( $et_paged - 1 ) * intval( $posts_number ) ) + intval( $offset_number );

			} else {

				$args['offset'] = intval( $offset_number );

			}

		}



		if ( is_single() && ! isset( $args['post__not_in'] ) ) {

			$args['post__not_in'] = array( get_the_ID() );

		}





        

		ob_start();

        

        ?>

            <script type="text/javascript">

                jQuery('document').ready(function(){

                    var windowWidth = jQuery(window).width();

                    if(windowWidth > 750){

                        var maxHeight = 0;

                        jQuery('.lama-posts-same-height').each(function(){

                            if(maxHeight < jQuery(this).height()){

                                maxHeight = jQuery(this).height();

                            }

                        });

                        jQuery('.lama-posts-same-height').each(function(){

                            jQuery(this).height(maxHeight);

                        });   

                    }

                    

                    jQuery(window).resize(function() {

                        var windowWidth = jQuery(window).width();

                        if(windowWidth > 750){

                            var maxHeight = 0;

                            jQuery('.lama-posts-same-height').each(function(){

                                jQuery(this).height('auto'); 

                            });  

                            jQuery('.lama-posts-same-height').each(function(){

                                if(maxHeight < jQuery(this).height()){

                                    maxHeight = jQuery(this).height();

                                }

                            });

                            jQuery('.lama-posts-same-height').each(function(){

                                jQuery(this).height(maxHeight);

                            });   

                        }else{

                            jQuery('.lama-posts-same-height').each(function(){

                                jQuery(this).height('auto'); 

                            });   

                        }

                    });

                });

            </script>

        <?php

        

		query_posts( $args );



		if ( have_posts() ) {

			while ( have_posts() ) {

				the_post();



				$post_format = et_pb_post_format();



				$thumb = '';



				$width = 'on' === $fullwidth ? 1080 : 400;

				$width = (int) apply_filters( 'et_pb_blog_image_width', $width );



				$height = 'on' === $fullwidth ? 675 : 250;

				$height = (int) apply_filters( 'et_pb_blog_image_height', $height );

				$classtext = 'on' === $fullwidth ? 'et_pb_post_main_image' : '';

				$titletext = get_the_title();

				$thumbnail = get_thumbnail( $width, $height, $classtext, $titletext, $titletext, false, 'Blogimage' );

				$thumb = $thumbnail["thumb"];



				$no_thumb_class = '' === $thumb || 'off' === $show_thumbnail ? ' et_pb_no_thumb' : '';



				if ( in_array( $post_format, array( 'video', 'gallery' ) ) ) {

					$no_thumb_class = '';

				} ?>



			<article id="post-<?php the_ID(); ?>" <?php post_class( 'et_pb_post clearfix' . $no_thumb_class . $overlay_class . ($same_height == 'on' ? ' lama-posts-same-height' : '') ); ?>>



			<?php

				et_divi_post_format_content();



				if ( ! in_array( $post_format, array( 'link', 'audio', 'quote' ) ) ) {

					if ( 'video' === $post_format && false !== ( $first_video = et_get_first_video() ) ) :

						$video_overlay = has_post_thumbnail() ? sprintf(

							'<div class="et_pb_video_overlay" style="background-image: url(%1$s); background-size: cover;">

								<div class="et_pb_video_overlay_hover">

									<a href="#" class="et_pb_video_play"></a>

								</div>

							</div>',

							$thumb

						) : '';



						printf(

							'<div class="et_main_video_container">

								%1$s

								%2$s

							</div>',

							$video_overlay,

							$first_video

						);

					elseif ( 'gallery' === $post_format ) :

						et_pb_gallery_images( 'slider' );

					elseif ( '' !== $thumb && 'on' === $show_thumbnail ) :

						if ( 'on' !== $fullwidth ) echo '<div class="et_pb_image_container">'; ?>

							<a href="<?php esc_url( the_permalink() ); ?>" class="entry-featured-image-url">

								<?php print_thumbnail( $thumb, $thumbnail["use_timthumb"], $titletext, $width, $height ); ?>

								<?php if ( 'on' === $use_overlay ) {

									echo $overlay_output;

								} ?>

							</a>

					<?php

						if ( 'on' !== $fullwidth ) echo '</div> <!-- .et_pb_image_container -->';

					endif;

				} ?>



			<?php if ( 'off' === $fullwidth || ! in_array( $post_format, array( 'link', 'audio', 'quote' ) ) ) { ?>

				<?php if ( ! in_array( $post_format, array( 'link', 'audio' ) ) ) { ?>

					<h2 class="entry-title"><a href="<?php esc_url( the_permalink() ); ?>"><?php the_title(); ?></a></h2>

				<?php } ?>



				<?php

					if ( 'on' === $show_author || 'on' === $show_date || 'on' === $show_categories || 'on' === $show_comments ) {

						printf( '<p class="post-meta">%1$s %2$s %3$s %4$s %5$s %6$s %7$s</p>',

							(

								'on' === $show_author

									? et_get_safe_localization( sprintf( __( 'by %s', 'et_builder' ), '<span class="author vcard">' .  et_pb_get_the_author_posts_link() . '</span>' ) )

									: ''

							),

							(

								( 'on' === $show_author && 'on' === $show_date )

									? ' | '

									: ''

							),

							(

								'on' === $show_date

									? et_get_safe_localization( sprintf( __( '%s', 'et_builder' ), '<span class="published">' . esc_html( get_the_date( $meta_date ) ) . '</span>' ) )

									: ''

							),

							(

								(( 'on' === $show_author || 'on' === $show_date ) && 'on' === $show_categories)

									? ' | '

									: ''

							),

							(

								'on' === $show_categories

									? get_the_category_list(', ')

									: ''

							),

							(

								(( 'on' === $show_author || 'on' === $show_date || 'on' === $show_categories ) && 'on' === $show_comments)

									? ' | '

									: ''

							),

							(

								'on' === $show_comments

									? sprintf( esc_html( _nx( '1 Comment', '%s Comments', get_comments_number(), 'number of comments', 'et_builder' ) ), number_format_i18n( get_comments_number() ) )

									: ''

							)

						);

					}



					echo '<div class="post-content">';

					global $et_pb_rendering_column_content;



					$post_content = et_strip_shortcodes( et_delete_post_first_video( get_the_content() ), true );



					$et_pb_rendering_column_content = true;



					if ( 'on' === $show_content_on ) {

                        if ( 'on' === $show_content ) {

                            global $more;



                            // page builder doesn't support more tag, so display the_content() in case of post made with page builder

                            if ( et_pb_is_pagebuilder_used( get_the_ID() ) ) {

                                $more = 1;

                                echo apply_filters( 'the_content', $post_content );

                            } else {

                                $more = null;

                                echo apply_filters( 'the_content', et_delete_post_first_video( get_the_content( esc_html__( ($read_more_text != '' ? $read_more_text : 'read more...'), 'et_builder' ) ) ) );

                            }

                        } else {

                            if ( has_excerpt() ) {

                                the_excerpt();

                            } else {

                                echo wpautop( et_delete_post_first_video( strip_shortcodes( truncate_post( 270, false, '', true ) ) ) );

                            }

                        }

                    } 



					$et_pb_rendering_column_content = false;



					if ( 'on' !== $show_content ) {

						$more = 'on' == $show_more ? sprintf( ' <a href="%1$s" class="more-link ' . ($more_align == 'on' ? 'lama-read-more-left-align' : 'lama-read-more-right-align') . '">%2$s</a>' , esc_url( get_permalink() ), esc_html__( ($read_more_text != '' ? $read_more_text : 'read more'), 'et_builder' ) )  : '';

						echo $more;

					}



					echo '</div>';

					?> 

			<?php } // 'off' === $fullwidth || ! in_array( $post_format, array( 'link', 'audio', 'quote', 'gallery' ?>



			</article> <!-- .et_pb_post -->

	<?php

			} // endwhile



			if ( 'on' === $show_pagination && ! is_search() ) {

				echo '</div> <!-- .et_pb_posts -->';



				$container_is_closed = true;



				if ( function_exists( 'wp_pagenavi' ) ) {

					wp_pagenavi();

				} else {

					if ( et_is_builder_plugin_active() ) {

						include( ET_BUILDER_PLUGIN_DIR . 'includes/navigation.php' );

					} else {

						get_template_part( 'includes/navigation', 'index' );

					}

				}

			}

		} else {

			if ( et_is_builder_plugin_active() ) {

				include( ET_BUILDER_PLUGIN_DIR . 'includes/no-results.php' );

			} else {

				get_template_part( 'includes/no-results', 'index' );

			}

		}



		wp_reset_query();



        $posts = ob_get_contents();



		ob_end_clean();



		$class = " et_pb_module et_pb_bg_layout_{$background_layout}";



		$output = sprintf(

			'<div%5$s class="%1$s%3$s%6$s"%7$s>

				%2$s

			%4$s',

			( 'on' === $fullwidth ? 'et_pb_posts' : 'et_pb_blog_grid clearfix' ),

			$posts,

			esc_attr( $class ),

			( ! $container_is_closed ? '</div> <!-- .et_pb_posts -->' : '' ),

			( '' !== $module_id ? sprintf( ' id="%1$s"', esc_attr( $module_id ) ) : '' ),

			( '' !== $module_class ? sprintf( ' %1$s', esc_attr( $module_class ) ) : '' ),

			( 'on' !== $fullwidth ? ' data-columns' : '' )

		);



		if ( 'on' !== $fullwidth )

			$output = sprintf( '<div class="et_pb_blog_grid_wrapper">%1$s</div>', $output );



		// Restore $wp_filter

		$wp_filter = $wp_filter_cache;

		unset($wp_filter_cache);



		return $output;

	}

}

new ET_Builder_Module_Blog_lama;